import { createToken, Lexer } from "chevrotain";
import { genVocabulary } from "./vocabularyGenerator";
export var whiteSpace = createToken({
    name: "whiteSpace",
    pattern: /\s+/,
    group: Lexer.SKIPPED
});
export var identifier = createToken({
    name: "identifier",
    pattern: Lexer.NA
});
export var months = createToken({
    name: "months",
    pattern: /JAN|FEB|MAR|APR|MAY|JUN|JUL|AUG|SEP|OCT|NOV|DEC/,
    categories: [identifier]
});
export var days = createToken({
    name: "days",
    pattern: /SUN|MON|TUE|WED|THU|FRI|SAT/,
    categories: [identifier]
});
export var dash = createToken({ name: "dash", pattern: /-/ });
export var slash = createToken({ name: "slash", pattern: /\// });
export var comma = createToken({ name: "comma", pattern: /,/ });
export var integer = createToken({
    name: "integer",
    pattern: /[0-9]{1,2}/,
    categories: [identifier]
});
export var every = createToken({
    name: "every",
    pattern: /\*/,
    categories: [identifier]
});
// Base tokens
export var cronTokens = [whiteSpace, identifier, months, days, dash, slash, comma, integer, every];
export var cronVocabulary = genVocabulary(cronTokens);
