import { __spreadArrays } from "tslib";
import { createToken } from "chevrotain";
import { cronTokens, identifier } from "./cron";
import { genVocabulary } from "./vocabularyGenerator";
// Quartz specific
export var anyToken = createToken({
    name: "anyToken",
    pattern: /\?/,
    categories: [identifier]
});
export var sharp = createToken({ name: "sharp", pattern: /#/ });
export var last = createToken({
    name: "last",
    pattern: /L/,
    categories: [identifier]
});
export var weekday = createToken({
    name: "weekday",
    pattern: /W/,
    categories: [identifier]
});
// Available tokens for Quartz cron
export var quartzTokens = __spreadArrays(cronTokens, [anyToken, sharp, last, weekday]);
export var quartzVocabulary = genVocabulary(quartzTokens);
