import { __extends } from "tslib";
import { CstParser } from "chevrotain";
import { comma, dash, identifier, slash } from "@/lexer";
var CronParser = /** @class */ (function (_super) {
    __extends(CronParser, _super);
    function CronParser(vocabulary, invokedByChild) {
        if (invokedByChild === void 0) { invokedByChild = false; }
        var _this = _super.call(this, vocabulary) || this;
        _this.cronExpression = _this.RULE("cronExpression", function () {
            // Minutes
            _this.SUBRULE1(_this.expression, { LABEL: "minutes" });
            // Hours
            _this.SUBRULE2(_this.expression, { LABEL: "hours" });
            // Day of month
            _this.SUBRULE3(_this.expression, { LABEL: "dom" });
            // Month
            _this.SUBRULE4(_this.expression, { LABEL: "month" });
            // Day of week
            _this.SUBRULE5(_this.expression, { LABEL: "dow" });
        });
        _this.expression = _this.RULE("expression", function () {
            _this.AT_LEAST_ONE_SEP({
                SEP: comma,
                DEF: function () { return _this.SUBRULE(_this.exprNotUnion); }
            });
        });
        _this.exprNotUnion = _this.RULE("exprNotUnion", function () {
            _this.CONSUME(identifier, { LABEL: "lhs" });
            _this.SUBRULE(_this.atomicExpr);
        });
        _this.atomicExpr = _this.RULE("atomicExpr", function () {
            _this.OPTION1({
                DEF: function () { return _this.SUBRULE1(_this.range); }
            });
            _this.OPTION2({
                DEF: function () { return _this.SUBRULE2(_this.interval); }
            });
        });
        _this.interval = _this.RULE("interval", function () {
            _this.CONSUME1(slash);
            _this.CONSUME2(identifier, { LABEL: "rhs" });
        });
        _this.range = _this.RULE("range", function () {
            _this.CONSUME1(dash);
            _this.CONSUME2(identifier, { LABEL: "rhs" });
        });
        if (!invokedByChild) {
            _this.performSelfAnalysis();
        }
        return _this;
    }
    return CronParser;
}(CstParser));
export { CronParser };
