import { __extends } from "tslib";
import { identifier, integer, last, quartzVocabulary, sharp } from "@/lexer";
import { CronParser } from "./CronParser";
var QuartzParser = /** @class */ (function (_super) {
    __extends(QuartzParser, _super);
    function QuartzParser() {
        var _this = _super.call(this, quartzVocabulary, true) || this;
        _this.cronExpression = _this.OVERRIDE_RULE("cronExpression", function () {
            // Seconds
            _this.SUBRULE1(_this.expression, { LABEL: "second" });
            // Minutes
            _this.SUBRULE2(_this.expression, { LABEL: "minutes" });
            // Hours
            _this.SUBRULE3(_this.expression, { LABEL: "hours" });
            // Day of month
            _this.SUBRULE4(_this.expression, { LABEL: "dom" });
            // Month
            _this.SUBRULE5(_this.expression, { LABEL: "month" });
            // Day of week
            _this.SUBRULE6(_this.expression, { LABEL: "dow" });
            // Optional year
            _this.OPTION({
                DEF: function () { return _this.SUBRULE7(_this.expression, { LABEL: "year" }); }
            });
        });
        _this.exprNotUnion = _this.OVERRIDE_RULE("exprNotUnion", function () {
            _this.CONSUME(identifier, { LABEL: "lhs" });
            _this.OPTION({
                DEF: function () { return _this.OR([{ ALT: function () { return _this.SUBRULE(_this.dow); } }, { ALT: function () { return _this.SUBRULE(_this.atomicExpr); } }]); }
            });
        });
        // Day of week
        _this.dow = _this.RULE("dow", function () {
            _this.OR([
                { ALT: function () { return _this.CONSUME(last, { LABEL: "occurence" }); } },
                {
                    ALT: function () {
                        _this.CONSUME1(sharp);
                        _this.CONSUME2(integer, { LABEL: "occurence" });
                    }
                }
            ]);
        });
        _this.performSelfAnalysis();
        return _this;
    }
    return QuartzParser;
}(CronParser));
export { QuartzParser };
