import DualExpression from "@/syntax/cron/DualExpression";
import StringLiteral from "@/syntax/cron/StringLiteral";
/**
 * Convenience method to build an interval expression.
 * @param lhs The value to repeat
 * @param step The step value
 * @return A step expression
 */
export function stepExpr(lhs, step) {
    return new DualExpression(lhs, step, "/");
}
/**
 * Convenience function to build a range expression.
 * @param start The start value
 * @param end The end value
 */
export function rangeExpr(start, end) {
    return new DualExpression(start, end, "-");
}
/**
 * Alias node for the * value
 */
export var everyExpr = new StringLiteral("*");
/**
 * Alias node for the ? value
 */
export var anyExpr = new StringLiteral("?");
