import { __extends } from "tslib";
// Keep the imports to avoid cyclic dependencies
import CronExpression from "@/syntax/cron/CronExpression";
import { everyExpr, anyExpr } from "@/syntax/common";
var QuartzCronExpression = /** @class */ (function (_super) {
    __extends(QuartzCronExpression, _super);
    function QuartzCronExpression(minute, hour, dom, month, dow, second, year) {
        if (minute === void 0) { minute = everyExpr; }
        if (hour === void 0) { hour = everyExpr; }
        if (dom === void 0) { dom = everyExpr; }
        if (month === void 0) { month = everyExpr; }
        if (dow === void 0) { dow = anyExpr; }
        if (second === void 0) { second = everyExpr; }
        if (year === void 0) { year = everyExpr; }
        var _this = _super.call(this, minute, hour, dom, month, dow) || this;
        _this._second = second;
        _this._year = year;
        return _this;
    }
    QuartzCronExpression.prototype.value = function () {
        return this.second.value() + " " + _super.prototype.value.call(this) + " " + this.year.value();
    };
    Object.defineProperty(QuartzCronExpression.prototype, "second", {
        get: function () {
            return this._second;
        },
        set: function (s) {
            this._second = s;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(QuartzCronExpression.prototype, "year", {
        get: function () {
            return this._year;
        },
        set: function (v) {
            this._year = v;
        },
        enumerable: true,
        configurable: true
    });
    return QuartzCronExpression;
}(CronExpression));
export default QuartzCronExpression;
